package ${basePackage}.module.system.req;

import ${basePackage}.frame.base.BaseUpdateRequest;
import javax.validation.constraints.NotNull;
import org.hibernate.validator.constraints.Length;
import javax.validation.constraints.NotEmpty;

/**
 * RoleUpdateRequest - 角色更新
 *
 * @author wangbing
 * @version 0.0.1
 * @since 2019-12-24
 */
public class  RoleUpdateRequest extends BaseUpdateRequest {

    /**
     * 主键
     */
    @NotNull(message = "[id]主键不能为NULL")
    private Long id;

    /**
     * 角色名称
     */
    @NotEmpty(message = "[roleName]角色名称不能为空")
    @Length(min = 0, max = 50, message = "[roleName]角色名称长度不合法(0-50)")
    private String roleName;

    /**
     * 角色代码
     */
    @NotEmpty(message = "[roleCode]角色代码不能为空")
    @Length(min = 0, max = 50, message = "[roleCode]角色代码长度不合法(0-50)")
    private String roleCode;

    /**
     * 角色描述
     */
    @Length(min = 0, max = 50, message = "[roleComment]角色描述长度不合法(0-50)")
    private String roleComment;

    public Long getId() {
        return this.id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getRoleName() {
        return this.roleName;
    }

    public void setRoleName(String roleName) {
        this.roleName = roleName;
    }

    public String getRoleCode() {
        return this.roleCode;
    }

    public void setRoleCode(String roleCode) {
        this.roleCode = roleCode;
    }

    public String getRoleComment() {
        return this.roleComment;
    }

    public void setRoleComment(String roleComment) {
        this.roleComment = roleComment;
    }
}
