<#-- since 2017-01-01-->
<div id="app" v-cloak>
    <el-card class="box-card search">
        <el-form :inline="true" :model="vm" ref="vm" label-position="left" label-width="90px">
            <el-form-item label="部门代码" prop="deptCode">
                <el-input v-model="vm.deptCode" clearable size="small" placeholder="请输入部门代码"></el-input>
            </el-form-item>
            <el-form-item label="部门名称" prop="deptName">
                <el-input v-model="vm.deptName" clearable size="small" placeholder="请输入部门名称"></el-input>
            </el-form-item>
            <el-form-item label="部门别名" prop="deptAlias">
                <el-input v-model="vm.deptAlias" clearable size="small" placeholder="请输入部门别名"></el-input>
            </el-form-item>
            <el-form-item label="父部门代码" prop="supCode">
                <el-input v-model="vm.supCode" clearable size="small" placeholder="请输入父部门代码"></el-input>
            </el-form-item>
            <el-form-item label="父部门名称" prop="supName">
                <el-input v-model="vm.supName" clearable size="small" placeholder="请输入父部门名称"></el-input>
            </el-form-item>
            <el-form-item label="是否有效" prop="valid">
                <el-radio-group v-model="vm.valid" clearable size="small">
                    <el-radio :label="true">是</el-radio>
                    <el-radio :label="false">否</el-radio>
                </el-radio-group>
            </el-form-item>
            <el-form-item>
                <el-button type="primary" size="small" icon="el-icon-search" @click="onSearch">搜索</el-button>
                <el-button type="warning" size="small" icon="el-icon-refresh-left" @click="onReset('vm')">重置</el-button>
            </el-form-item>
        </el-form>
    </el-card>

    <el-card class="box-card data">
        <el-row>
            <el-col :span="12">
                <el-button type="success" size="small" icon="el-icon-plus" @click="onCreate">新增</el-button>

                <el-button type="warning" size="small" icon="el-icon-download" @click="onExport">导出</el-button>

                <el-dialog class="form" :title="form.title" :visible.sync="form.dialog">
                    <el-form :model="form" :inline="true" :rules="formRules" ref="form" label-position="left"
                             label-width="90px">
                        <el-form-item label="部门代码" prop="deptCode">
                            <el-input v-model="form.deptCode" clearable size="small" placeholder="请输入部门代码"></el-input>
                        </el-form-item>
                        <el-form-item label="部门名称" prop="deptName">
                            <el-input v-model="form.deptName" clearable size="small" placeholder="请输入部门名称"></el-input>
                        </el-form-item>
                        <el-form-item label="部门别名" prop="deptAlias">
                            <el-input v-model="form.deptAlias" clearable size="small" placeholder="请输入部门别名"></el-input>
                        </el-form-item>
                        <el-form-item label="父部门代码" prop="supCode">
                            <el-input v-model="form.supCode" clearable size="small" placeholder="请输入父部门代码"></el-input>
                        </el-form-item>
                        <el-form-item label="父部门名称" prop="supName">
                            <el-input v-model="form.supName" clearable size="small" placeholder="请输入父部门名称"></el-input>
                        </el-form-item>
                        <el-form-item label="是否有效" prop="valid">
                            <el-radio-group v-model="form.valid" clearable size="small">
                                <el-radio :label="true">是</el-radio>
                                <el-radio :label="false">否</el-radio>
                            </el-radio-group>
                        </el-form-item>
                    </el-form>
                    <span slot="footer" class="dialog-footer">
                        <el-button size="small" @click="form.dialog = false">取 消</el-button>
                        <el-button size="small" type="primary" @click="onSave">保存</el-button>
                    </span>
                </el-dialog>
            </el-col>

            <el-col :span="12">
                <el-button-group style="float: right;">
                    <el-tooltip effect="dark" content="Excel模板下载" placement="bottom">
                        <el-button size="small" icon="el-icon-date" @click="onTemplate"></el-button>
                    </el-tooltip>

                    <el-tooltip effect="dark" content="Excel导入" placement="bottom">
                        <el-button size="small" icon="el-icon-upload2" @click="onImport"></el-button>
                    </el-tooltip>

                    <el-tooltip effect="dark" content="批量删除" placement="bottom">
                        <el-button size="small" icon="el-icon-delete" @click="onBitchDelete"></el-button>
                    </el-tooltip>

                    <el-tooltip effect="dark" content="刷新" placement="bottom">
                        <el-button size="small" icon="el-icon-refresh" @click="onFind"></el-button>
                    </el-tooltip>
                </el-button-group>
            </el-col>
        </el-row>

        <el-table
                @selection-change="onSelectionChange"
                empty-text="无数据"
                :data="result"
                size="mini">
            <el-table-column
                    align="center"
                    type="selection"
                    width="40">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="id"
                    label="主键"
                    width="140">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="deptCode"
                    label="部门代码">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="deptName"
                    label="部门名称">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="deptAlias"
                    label="部门别名">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="supCode"
                    label="父部门代码">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="supName"
                    label="父部门名称">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="valid"
                    label="是否有效">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="createTime"
                    width="140"
                    label="创建时间">
            </el-table-column>
            <el-table-column
                    align="center"
                    fixed="right"
                    width="120"
                    label="操作">
                <template slot-scope="scope">
                    <el-dropdown size="mini" split-button type="primary" @click="onCommand(['edit',scope.row])"
                                 @command="onCommand">
                        <i class="el-icon-edit"></i>编辑
                        <el-dropdown-menu slot="dropdown">
                            <el-dropdown-item :command="['delete',scope.row]" icon="el-icon-delete">删除
                            </el-dropdown-item>
                        </el-dropdown-menu>
                    </el-dropdown>
                </template>
            </el-table-column>
        </el-table>

        <el-pagination
                background
                v-if="vm.totalCount > vm.pageSize"
                style="margin-top: 10px"
                @current-change="onPage"
                :current-page="vm.pageNumber"
                :page-size="vm.pageSize"
                layout="total, sizes, prev, pager, next, jumper"
                :total="vm.totalCount">
        </el-pagination>
    </el-card>
</div>
<script>
    var app = new Vue({
        mixins: [mixin],
        el: "#app",
        data: {
            module: 'system',
            target: 'dept',
            vm: {//条件及分页参数
                deptCode: "",
                deptName: "",
                deptAlias: "",
                supCode: "",
                supName: "",
                valid: "",
                pageNumber: 1,
                pageSize: 10,
                totalCount: 0,
                sortKey: 'CREATE_TIME',
                sortType: 'DESC'
            },
            form: {//待提交表单
                title: "",
                dialog: false,
                id: '',
                deptCode: "",
                deptName: "",
                deptAlias: "",
                supCode: "",
                supName: "",
                valid: "",
                rowVersion: ""
            },
            formRules: {
                deptCode: [
                    {required: true, message: '部门代码不能为空', trigger: 'blur'},
                    {min: 1, max: 50, message: '部门代码长度在 1 到 50 个字符', trigger: 'blur'}
                ],
                deptName: [
                    {required: true, message: '部门名称不能为空', trigger: 'blur'},
                    {min: 1, max: 100, message: '部门名称长度在 1 到 100 个字符', trigger: 'blur'}
                ],
                deptAlias: [
                    {min: 1, max: 50, message: '部门别名长度在 1 到 50 个字符', trigger: 'blur'}
                ],
                supCode: [
                    {min: 1, max: 50, message: '父部门代码长度在 1 到 50 个字符', trigger: 'blur'}
                ],
                supName: [
                    {min: 1, max: 100, message: '父部门名称长度在 1 到 100 个字符', trigger: 'blur'}
                ],
                valid: [
                    {required: true, message: '是否有效不能为空', trigger: 'blur'},
                ],
            }
        },
        methods: {
            onCreate: function () {
                this.form.title = "部门新增";
                this.form.dialog = true;
                this.form.id = "";
                this.form.deptCode = "";
                this.form.deptName = "";
                this.form.deptAlias = "";
                this.form.supCode = "";
                this.form.supName = "";
                this.form.valid = "";
            },
            onCommand: function (arg) {
                const cmd = arg[0];
                const item = arg[1];
                switch (cmd) {
                    case "edit":
                        this.form.title = "部门编辑";
                        this.form.dialog = true;
                        this.form.id = item.id;
                        this.form.deptCode = item.deptCode;
                        this.form.deptName = item.deptName;
                        this.form.deptAlias = item.deptAlias;
                        this.form.supCode = item.supCode;
                        this.form.supName = item.supName;
                        this.form.valid = item.valid;
                        this.form.rowVersion = item.rowVersion;
                        break;
                    case "delete":
                        this.onDelete(item);
                        break;
                    default:
                        this.w("未找到对应的命令");
                        break;
                }
            },
        },
        mounted: function () {
            this.onFind();
        },
    })
</script>
