<#-- since 2017-01-01-->
<div id="app" v-cloak>
    <el-card class="box-card search">
        <el-form :inline="true" :model="vm" ref="vm" label-position="left" label-width="90px">
            <el-form-item label="用户主键" prop="userId">
                <el-input v-model="vm.userId" clearable size="small" placeholder="请输入用户主键"></el-input>
            </el-form-item>
            <el-form-item label="用户名称" prop="userName">
                <el-input v-model="vm.userName" clearable size="small" placeholder="请输入用户名称"></el-input>
            </el-form-item>
            <el-form-item label="登录时间" prop="loginTime">
                <el-date-picker
                        size="small"
                        v-model="vm.loginTime"
                        format="yyyy-MM-dd HH:mm:ss"
                        value-format="yyyy-MM-dd HH:mm:ss"
                        type="datetime"
                        placeholder="选择日期时间">
                </el-date-picker>
            </el-form-item>
            <el-form-item label="是否有效" prop="valid">
                <el-radio-group v-model="vm.valid" clearable size="small">
                    <el-radio :label="true">是</el-radio>
                    <el-radio :label="false">否</el-radio>
                </el-radio-group>
            </el-form-item>
            <el-form-item label="部门名称" prop="deptName">
                <el-input v-model="vm.deptName" clearable size="small" placeholder="请输入部门名称"></el-input>
            </el-form-item>
            <el-form-item label="终端类型" prop="terminalType">
                <el-input-dict v-model="vm.terminalType" clearable size="small" placeholder="请输入终端类型" dict-name="TERMINAL_TYPE" ></el-input-dict>
            </el-form-item>
            <el-form-item>
                <el-button type="primary" size="small" icon="el-icon-search" @click="onSearch">搜索</el-button>
                <el-button type="warning" size="small" icon="el-icon-refresh-left" @click="onReset('vm')">重置</el-button>
            </el-form-item>
        </el-form>
    </el-card>

    <el-card class="box-card data">
        <el-row>
            <el-col :span="12">
                <el-button type="warning" size="small" icon="el-icon-download" @click="onExport">导出</el-button>
            </el-col>

            <el-col :span="12">
                <el-button-group style="float: right;">
                    <el-tooltip effect="dark" content="Excel模板下载" placement="bottom">
                        <el-button size="small" icon="el-icon-date" @click="onTemplate"></el-button>
                    </el-tooltip>

                    <el-tooltip effect="dark" content="Excel导入" placement="bottom">
                        <el-button size="small" icon="el-icon-upload2" @click="onImport"></el-button>
                    </el-tooltip>

                    <el-tooltip effect="dark" content="批量删除" placement="bottom">
                        <el-button size="small" icon="el-icon-delete" @click="onBitchDelete"></el-button>
                    </el-tooltip>

                    <el-tooltip effect="dark" content="刷新" placement="bottom">
                        <el-button size="small" icon="el-icon-refresh" @click="onFind"></el-button>
                    </el-tooltip>
                </el-button-group>
            </el-col>
        </el-row>

        <el-table
                @selection-change="onSelectionChange"
                empty-text="无数据"
                :data="result"
                size="mini">
            <el-table-column
                    align="center"
                    type="selection"
                    width="40">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="id"
                    label="主键"
                    width="140">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="valid"
                    label="是否有效">
                <template slot-scope="scope">
                    <el-tag size="mini" v-if="scope.row.valid">有效</el-tag>
                    <el-tag size="mini" type="danger" v-if="!scope.row.valid">无效</el-tag>
                </template>
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="userId"
                    label="用户主键">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="userName"
                    label="用户名称">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="loginTime"
                    label="登录时间">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="validTime"
                    label="有效时间">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="deptId"
                    label="部门主键">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="deptCode"
                    label="部门代码">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="deptName"
                    label="部门名称">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="terminalType"
                    label="终端类型">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="terminalIp"
                    label="终端地址">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="terminalInfo"
                    label="终端信息">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="createTime"
                    width="140"
                    label="创建时间">
            </el-table-column>
            <el-table-column
                    align="center"
                    fixed="right"
                    width="120"
                    label="操作">
                <template slot-scope="scope">
                    <el-dropdown size="mini" split-button type="primary" @click="onCommand(['edit',scope.row])"
                                 @command="onCommand">
                        <i class="el-icon-edit"></i>编辑
                        <el-dropdown-menu slot="dropdown">
                            <el-dropdown-item :command="['delete',scope.row]" icon="el-icon-delete">删除
                            </el-dropdown-item>
                        </el-dropdown-menu>
                    </el-dropdown>
                </template>
            </el-table-column>
        </el-table>

        <el-pagination
                background
                v-if="vm.totalCount > vm.pageSize"
                style="margin-top: 10px"
                @current-change="onPage"
                :current-page="vm.pageNumber"
                :page-size="vm.pageSize"
                layout="total, sizes, prev, pager, next, jumper"
                :total="vm.totalCount">
        </el-pagination>
    </el-card>
</div>
<script>
    var app = new Vue({
        mixins: [mixin],
        el: "#app",
        data: {
            module: 'system',
            target: 'tokens',
            vm: {//条件及分页参数
                userId: "",
                userName: "",
                loginTime: "",
                validTime: "",
                valid: "",
                deptId: "",
                deptCode: "",
                deptName: "",
                terminalType: "",
                terminalIp: "",
                terminalInfo: "",
                pageNumber: 1,
                pageSize: 10,
                totalCount: 0,
                sortKey:'CREATE_TIME',
                sortType:'DESC'
            },
            form: {//待提交表单
                title: "",
                dialog: false,
                id: '',
                userId: "",
                userName: "",
                loginTime: "",
                validTime: "",
                valid: "",
                deptId: "",
                deptCode: "",
                deptName: "",
                terminalType: "",
                terminalIp: "",
                terminalInfo: "",
                rowVersion: ""
            },
            formRules: {
                userId: [
                    {required: true, message: '用户主键不能为空', trigger: 'blur'},
                ],
                userName: [
                    {required: true, message: '用户名称不能为空', trigger: 'blur'},
                    {min: 1, max: 50, message: '用户名称长度在 1 到 50 个字符', trigger: 'blur'}
                ],
                loginTime: [
                    {required: true, message: '登录时间不能为空', trigger: 'blur'},
                ],
                validTime: [
                    {required: true, message: '有效时间不能为空', trigger: 'blur'},
                ],
                valid: [
                    {required: true, message: '是否有效不能为空', trigger: 'blur'},
                ],
                deptId: [
                ],
                deptCode: [
                    {min: 1, max: 50, message: '部门代码长度在 1 到 50 个字符', trigger: 'blur'}
                ],
                deptName: [
                    {min: 1, max: 100, message: '部门名称长度在 1 到 100 个字符', trigger: 'blur'}
                ],
                terminalType: [
                ],
                terminalIp: [
                    {min: 1, max: 50, message: '终端地址长度在 1 到 50 个字符', trigger: 'blur'}
                ],
                terminalInfo: [
                    {min: 1, max: 100, message: '终端信息长度在 1 到 100 个字符', trigger: 'blur'}
                ],
            }
        },
        methods: {
            onCommand: function (arg) {
                const cmd = arg[0];
                const item = arg[1];
                switch (cmd) {
                    case "edit":
                        this.form.title = "通行证编辑";
                        this.form.dialog = true;
                        this.form.id = item.id;
                        this.form.userId = item.userId;
                        this.form.userName = item.userName;
                        this.form.loginTime = item.loginTime;
                        this.form.validTime = item.validTime;
                        this.form.valid = item.valid;
                        this.form.deptId = item.deptId;
                        this.form.deptCode = item.deptCode;
                        this.form.deptName = item.deptName;
                        this.form.terminalType = item.terminalType;
                        this.form.terminalIp = item.terminalIp;
                        this.form.terminalInfo = item.terminalInfo;
                        this.form.rowVersion = item.rowVersion;
                        break;
                    case "delete":
                        this.onDelete(item);
                        break;
                    default:
                        this.w("未找到对应的命令");
                        break;
                }
            },
        },
        mounted: function () {
            this.onFind();
        },
    })
</script>
